package milab.lab05.webcamAgent;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Rectangle;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class WebcamAgentFrame extends JFrame{

	private static final long serialVersionUID = 7259230094004369034L;
	private ImageCanvas canvas;
	private ImageCanvas canvas2;
	private ImageCanvas canvas3;
	private JButton grabButton;
	
	public WebcamAgentFrame(WebcamAgent parent){
		super("WebcamAgent");
		canvas = new ImageCanvas(WebcamAgent.H, WebcamAgent.H);
		JPanel p = new JPanel();
		p.add(canvas);
		JPanel p2 = new JPanel();
		p2.setLayout(new GridLayout(2, 1));
		canvas2 = new ImageCanvas(WebcamAgent.H/2,WebcamAgent.H/2);
		p2.add(canvas2);
		canvas3 = new ImageCanvas(WebcamAgent.H/2,WebcamAgent.H/2);
		p2.add(canvas3);
		p.add(p2);
		JPanel p3 = new JPanel();
		p3.setLayout(new BorderLayout(10,10));
		p3.add(p, BorderLayout.CENTER);
		grabButton = new JButton("Grab it!"); 
		p3.add(grabButton, BorderLayout.SOUTH);
		grabButton.addActionListener(parent);
		
		this.add(p3);
		this.pack();
		this.setResizable(false);
		Rectangle r = this.getGraphicsConfiguration().getBounds();
		setLocation((r.width-this.getWidth())/2,(r.height-this.getHeight())/2);
		this.setBackground(Color.black);
	}
	public void setImage(Image image){
		canvas.setImage(image);
	}
	public void setSmallImage(Image image){
		canvas2.setImage(image);
	}
	public void setSmallLowResImage(Image image){
		canvas3.setImage(image);
	}
	
	public void grabbed(){
		grabButton.setText("Start over!");
	}
	public void startAgain(){
		grabButton.setText("Grab it!");
	}
	
	private class ImageCanvas extends Canvas{

		private static final long serialVersionUID = -6634135245457074733L;

		protected Image shot;
		
		public void addNotify(){
			super.addNotify();
			createBufferStrategy(2);
		}
		public ImageCanvas(int x, int y){
			setSize(x,y);
			shot = null;
		}
		
		@Override
	    public void paint(Graphics g){
			getBufferStrategy().show();
			Graphics bg = getBufferStrategy().getDrawGraphics();	
			
	    	if (shot!=null){
	    		bg.drawImage(shot,0,0,shot.getWidth(null),shot.getWidth(null),Color.BLACK, this);
	    	}
	    }
	    public void setImage(Image shot){
	    	this.shot = shot;
	    	repaint();
	    }	
	}
		
}
